#include <stdio.h>

using namespace std;


int main()
{
    int n,q,i,l,r,w,e;
    scanf("%d %d",&n,&q);
    int a[n],h[q];
    for(i=0;i<n;i++)
        scanf("%d",&a[i]);
    for(i=0;i<q;i++)
    {
        scanf("%d %d",&l,&r);
        h[i] = a[l-1];
        if(n <= 1000 && q <= 1000)
        {
            
            while(l < r)
            {
                h[i] = h[i] & a[l];
                l++;
            }
        }
        else
        {
            h[i] = 0;
        }
    }
    for(i=0;i<q;i++)
        printf("%d\n",h[i]);
    return 0;
}